# 目录

[Go语言高级编程](index.md)
[前言](preface.md)

- [语言基础](ch1-basic/readme.md)
  - [Go语言创世纪](ch1-basic/ch1-01-genesis.md)
  - [Hello, World 的革命](ch1-basic/ch1-02-hello-revolution.md)
  - [数组、字符串和切片](ch1-basic/ch1-03-array-string-and-slice.md)
  - [函数、方法和接口](ch1-basic/ch1-04-func-method-interface.md)
  - [面向并发的内存模型](ch1-basic/ch1-05-mem.md)
  - [常见的并发模式](ch1-basic/ch1-06-goroutine.md)
  - [错误和异常](ch1-basic/ch1-07-error-and-panic.md)
  - [补充说明](ch1-basic/ch1-08-ext.md)
- [CGO编程](ch2-cgo/readme.md)
   - [快速入门](ch2-cgo/ch2-01-hello-cgo.md)
   - [CGO基础](ch2-cgo/ch2-02-basic.md)
   - [类型转换](ch2-cgo/ch2-03-cgo-types.md)
   - [函数调用](ch2-cgo/ch2-04-func.md)
   - [内部机制](ch2-cgo/ch2-05-internal.md)
   - [实战: 封装qsort](ch2-cgo/ch2-06-qsort.md)
   - [CGO内存模型](ch2-cgo/ch2-07-memory.md)
   - [C++类包装](ch2-cgo/ch2-08-class.md)
   - [静态库和动态库](ch2-cgo/ch2-09-static-shared-lib.md)
   - [编译和链接参数](ch2-cgo/ch2-10-link.md)
   - [补充说明](ch2-cgo/ch2-11-ext.md)
- [汇编语言](ch3-asm/readme.md)
   - [快速入门](ch3-asm/ch3-01-basic.md)
   - [计算机结构](ch3-asm/ch3-02-arch.md)
   - [常量和全局变量](ch3-asm/ch3-03-const-and-var.md)
   - [函数](ch3-asm/ch3-04-func.md)
   - [控制流](ch3-asm/ch3-05-control-flow.md)
   - [再论函数](ch3-asm/ch3-06-func-again.md)
   - [汇编语言的威力](ch3-asm/ch3-07-hack-asm.md)
   - [例子：Goroutine ID](ch3-asm/ch3-08-goroutine-id.md)
   - [Delve调试器](ch3-asm/ch3-09-debug.md)
   - [补充说明](ch3-asm/ch3-10-ext.md)
- [第4章 RPC和Protobuf](ch4-rpc/readme.md)
   - [RPC入门](ch4-rpc/ch4-01-rpc-intro.md)
   - [Protobuf](ch4-rpc/ch4-02-pb-intro.md)
   - [玩转RPC](ch4-rpc/ch4-03-netrpc-hack.md)
   - [gRPC入门](ch4-rpc/ch4-04-grpc.md)
   - [gRPC进阶](ch4-rpc/ch4-05-grpc-hack.md)
   - [gRPC和Protobuf扩展](ch4-rpc/ch4-06-grpc-ext.md)
   - [pbgo: 基于Protobuf的框架](ch4-rpc/ch4-07-pbgo.md)
   - [grpcurl工具](ch4-rpc/ch4-08-grpcurl.md)
   - [补充说明](ch4-rpc/ch4-09-ext.md)
- [Go和Web](ch5-web/readme.md)
   - [Web开发简介](ch5-web/ch5-01-introduction.md)
   - [请求路由](ch5-web/ch5-02-router.md)
   - [中间件](ch5-web/ch5-03-middleware.md)
   - [请求校验](ch5-web/ch5-04-validator.md)
   - [和数据库打交道](ch5-web/ch5-05-database.md)
   - [服务流量限制](ch5-web/ch5-06-ratelimit.md)
   - [大型Web项目分层](ch5-web/ch5-07-layout-of-web-project.md)
   - [接口和表驱动开发](ch5-web/ch5-08-interface-and-web.md)
   - [灰度发布和A/B测试](ch5-web/ch5-09-gated-launch.md)
   - [补充说明](ch5-web/ch5-10-ext.md)
- [分布式系统](ch6-cloud/readme.md)
   - [分布式 id 生成器](ch6-cloud/ch6-01-dist-id.md)
   - [分布式锁](ch6-cloud/ch6-02-lock.md)
   - [延时任务系统](ch6-cloud/ch6-03-delay-job.md)
   - [分布式搜索引擎](ch6-cloud/ch6-04-search-engine.md)
   - [负载均衡](ch6-cloud/ch6-05-load-balance.md)
   - [分布式配置管理](ch6-cloud/ch6-06-config.md)
   - [分布式爬虫](ch6-cloud/ch6-07-crawler.md)
   - [补充说明](ch6-cloud/ch6-08-ext.md)
- [附录](appendix/readme.md)
   - [附录A: Go语言常见坑](appendix/appendix-a-trap.md)
   - [附录B: 有趣的代码片段](appendix/appendix-b-gems.md)
   - [附录C: 作者简介](appendix/appendix-c-author.md)
